CR .( LARGE FACTORIAL    SCR#01)

: TASK ;

( JUPITER ACE'S DEFINER WORD   )
: DEFINER ( -- )
  [COMPILE] : COMPILE CREATE ;
HEX

: SPACES  ( N -- )
   0 MAX ?DUP IF 0
   DO SPACE LOOP THEN ;

: U.R ( U N -- )
  SWAP 0 <# #S #>
  ROT OVER -
  SPACES TYPE ;

DEFINER BYTE-ARRAY      ( N -- )
 ALLOT DOES> + ;    ( N -- ADR )


( LARGE FACTORIAL        SCR#02)

4000 CONSTANT MAX-DIGITS
MAX-DIGITS BYTE-ARRAY F-BUFF
0 VARIABLE LAST ( LST BUFF ELEM)

: *BUFF            ( MULTIPLIER)
  0                     ( CARRY)
  LAST @ 1+ 0
  DO
   OVER I F-BUFF C@ * + 10 /MOD
   SWAP I F-BUFF C!
  LOOP
  BEGIN     ( EXTEND BUFFER TO )
          ( ACCEPT FINAL CARRY )
   ?DUP
  WHILE
   10 /MOD SWAP 1 LAST +! LAST @
   DUP 1+ MAX-DIGITS >
   IF ." OUT OF BUFFER" QUIT
   THEN  F-BUFF C!
 REPEAT DROP ;
 


( LARGE FACTORIAL        SCR#03)
: SETUP
  1 0 F-BUFF C!  ( START BUFF=1)
  0 LAST ! ;

: .FAC
  LAST @ 1+ 0
  DO
   LAST @ I - DUP 1+ 3 MOD 0= I 
   0= 0= AND IF ASCII , EMIT
             THEN
   F-BUFF C@ 1 U.R
  LOOP SLOW ;

: FAC
  SETUP 1+ 1 DO I *BUFF  LOOP ;

: FACS
  SETUP 1+ 1 CR
  DO
   I *BUFF ." FACTORIAL"
   I 3 U.R ."  = " .FAC CR
  LOOP ;


( LARGE FACTORIAL        SCR#04)
CR .( 20 FACS)
20 FACS

CR .( 100 FAC .FAC)
100 FAC .FAC
( 00:01:07 IN SLOW MODE )
( 00:00:42 IN FAST MODE )
















.
