\ Sieve of Eratosthenes
\ Roseta Code - http://rosettacode.org/wiki/Sieve_of_Eratosthenes#Forth

: ERASE  ( addr n -- )
  ?DUP IF OVER + SWAP
          DO 0 I C! LOOP
       ELSE DROP
       THEN
;

: PRIME? ( N -- ? ) PAD + C@ 0= ;
: COMPOSITE! ( N -- ) PAD + 1 SWAP C! ;

: SIEVE ( N -- )
  PAD OVER ERASE
  2
  BEGIN
    2DUP DUP * >
  WHILE
    DUP PRIME? IF
      2DUP DUP * DO
        I COMPOSITE!
      DUP +LOOP
    THEN
    1+
  REPEAT
  DROP
  ." PRIMES: " 2 DO I PRIME? IF I . THEN LOOP ;
